// MIRSAK パトロール走行
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "mirsak.h"
#include "patrol_sequence.h"
#include "hardware.h"
#include "direction.h"
#include "run_ctrl.h"
#include "number.h"

//enum run_mode run_mode;

//static void get_patrol_data(int i, char *style, int *value)
static void get_patrol_data(int i, int *style, int *value)
{
	struct patrol_data *data;
	data = pt_data;
	*style=(data+i)->style;
	*value=(data+i)->value;
}


//正体補正をするシーケンス番号
static int dir_number[3] ={4};

//数字認識する場所のシーケンス番号
static int num_number[3] ={4};

void mirsak_patrol(){

	float default_speed = 80.0; //直進速度[cm/sec] 
	float default_speed_rot = 30.0; //回転速度 [deg/sec]
	int max_sequence_num=4; //終了までのシーケンス数 10→4に変更した。まだよくわからん。
	float speed;
	int sequence_num=1;
	int dcount =0;
	int ncount =0;
	//int left_num, right_num;
	int face_distance = 50; //正体補正する距離
	//数字ボードまでの距離 = 正体補正距離 - (カメラとUSS先端の距離差）
	int num_distance = face_distance - CAM_USS_DIF ; 
	int numbers[2];

	int style=0;
	int value=0;
	int ret_val;

	number_set_nums(1); //ボード上の数字の数を1にセット

	while(1){

		get_patrol_data(sequence_num-1, &style, &value); 
		printf("sequence_num=%d     style=%d      value=%d   \n", sequence_num, style, value);
		if(style==STRAIGHT){
			if(value>0){
				speed=default_speed;
			}else{
				speed=-default_speed;
			}
		}
		if(style==ROTATE){
			if(value>0){
				speed=default_speed_rot;
			}else{
				speed=-default_speed_rot;
			}
		}

		run_ctrl_set(style, speed); 
		run_ctrl_set_dist((float)value);
		run_ctrl_create();

		// endflag が 1 になるまで loop する
		while(1){
			if(run_ctrl_get_endflag()==1) break;
			 usleep(20000);
		}
		run_ctrl_cancel();

		//指定したシーケンスで正体補正する
		if(dir_number[dcount]==sequence_num){
			ret_val=direction_correct(face_distance);
			dcount++;
		}
		//指定したシーケンスで数字認識する
		if(num_number[ncount]==sequence_num){
			ret_val = number_detect(num_distance); //数字認識
        		number_get(numbers);
                	printf("左数字=%d、右数字=%d\n",numbers[0],numbers[1]);
			ncount++;
		}

		sequence_num++;
		//終了シーケンス数になったら while を抜け、終了
		if(sequence_num > max_sequence_num) break;

		usleep(1000*10);

	}

	run_ctrl_stop();
	usleep(1000*1000);

}
