#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "hardware.h"
#include "device.h"
#include "test.h"

int main(){

	int ret_val;

	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();

    //以下のいずれかをコメントアウトする
	//test_pwm(); //PWMのテスト
	//test_motor(); //モータのテスト
	//test_encoder(); //エンコーダのテスト
	//test_pwm_vel(); //PWM値と走行速度の確認テスト
	//test_vel_ctrl(); //モータ速度制御のテスト
	//test_distance(); //距離計の確認テスト
	test_run_ctrl(); //走行制御テスト
	//test_uss(); //超音波センサテスト
	//test_direction(); //正体補正テスト
	//test_number(); //数字認識テスト
	//test_dir_num(); //正体補正＆数字認識テスト
	//test_io(); //IOデバイステスト
	//test_comm(); //サーバ通信テスト

	ret_val=device_encoder_close();
	ret_val=device_motor_close();
	ret_val=device_uss_close();
	ret_val=device_io_close();

	return 0;

}

