/*
超音波センサによる距離計測を行うモジュール
MG3で開発されたソースを改良した。

2014/07/14	by S.Ushimaru 
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include "uss.h"
#include "device.h"

static int fd0;

int uss_get(int uss_num){

	//超音波センサの測定誤差（= 実際の距離 - 計測値）[cm]
	int uss_error[8] = {0, 0, 0, 0, 0, 0, 0, 0};

	// unsigned char rs_rbuffer[2];
	// unsigned char rs_sbuffer[1];
	unsigned char rs_rbuffer[2];
	unsigned char rs_sbuffer[2];
	//char rs_sbuffer;
	int c,x;
	int data = 99999;
	int i=0;
	struct termios oldtio;
	if(uss_num < 0 || uss_num > 4) return(-1);
	//memset(rs_rbuffer,'\0',2);
	//memset(rs_sbuffer,'\0',1);

	//printf("maker1 \n");
	sprintf((char*)rs_sbuffer,"%c",(char)uss_num);

	//sprintf(rs_sbuffer,"%c",(char)uss_num);

	//fd0=open(S_PORT,O_RDWR | O_NOCTTY | O_NONBLOCK);
	fd0=device_uss_get();
	//printf("maker fd0=%d\n",fd0);
	if(fd0 <= 0) exit(-1);
	uss_set_serial_port(fd0,&oldtio);

	uss_put_serial_string(fd0,(char*)rs_sbuffer);
	while(1){
		c=0;
		c=uss_get_serial_char(fd0);
		rs_rbuffer[i] = c;
		i++;
		if(i==2){
		if(rs_rbuffer[1]==0xff){
		//printf("\"%s\" receive no response\n",S_PORT);
		data = 99999;
		break;
		}
			c=rs_rbuffer[1];
			x=c<<8;
			c=rs_rbuffer[0];
			data=x+c+20;
//			memset(rs_rbuffer,'\0',2);
			break;
		}
	}

	//uss_close_serial_port(fd0,&oldtio);

	data += uss_error[uss_num-1];

	return (data);
}
